
 Xa99 Cross Assembler
FNCARG 24/03/2007                                            PAGE 0001
  0001            *
  0002            * C99 Function call with 1 through 6 arguments
  0003            *
  0004            * Frederik G. Kaal 30/10/2005
  0005            * Revisited: 24/03/2007: Enabled FARG#1
  0006            *
  0008            
  0009                   IDT 'FNCARG'
  0010            
  0011            * Method for calling C99 function with 1 through 8 arguments
  0012            * A simple function call with 1 through 8 argument can be
  0013            * in the following manner:
  0014            *
  0015            * LI   8,ARG1		LI   1,ARG1
  0016            * BL   15		LI   2,ARG2
  0017            * LI   8,ARG2		LI   3,ARG3
  0018            * BL   15		LI   4,ARG4
  0019            * LI   8,ARG3		LI   5,ARG5
  0020            * BL   15		LI   6,ARG6
  0021            * LI   8,ARG4		LI   7,ARG7
  0022            * BL   15		LI   8,ARG8
  0023            * LI   8,ARG5		BL   @FARG#x
  0024            * BL   15		DATA FUNC
  0025            * LI   8,ARG6
  0026            * BL   15
  0027            * LI   8,ARG7
  0028            * BL   15
  0029            * LI   8,ARG8
  0030            * BL   15
  0031            * BL   *12
  0032            * DATA FUNC
  0033            *
  0034            * Code is shorter when a function is called with more
  0035            * than 1 argument.
  0036            
  0037            	DEF	FARG#1,FARG#2,FARG#3,FARG#4,FARG#5,FARG#6,FARG#7,FARG#8
  0038            	
  0039 0000 064E  FARG#8	DECT	14
  0040 0002 C781  	MOV	1,*14
  0041 0004 064E  FARG#7	DECT	14
  0042 0006 C782  	MOV	2,*14
  0043 0008 064E  FARG#6	DECT	14
  0044 000A C783  	MOV	3,*14
  0045 000C 064E  FARG#5	DECT	14
  0046 000E C784  	MOV	4,*14
  0047 0010 064E  FARG#4	DECT	14
  0048 0012 C785  	MOV	5,*14
  0049 0014 064E  FARG#3	DECT	14
  0050 0016 C786  	MOV	6,*14
  0051 0018 064E  FARG#2	DECT	14
  0052 001A C787  	MOV	7,*14
  0053 001C 064E  FARG#1	DECT	14
  0054 001E C788  	MOV	8,*14
  0055 0020 C03B  	MOV	*11+,0
  0056 0022 064E  	DECT	14
  0057 0024 C78B  	MOV	11,*14
  0058 0026 0450  	B	*0
  0059            	
  0060            	END

 Xa99 Cross Assembler
FNCARG 24/03/2007                                            PAGE 0002
  D FARG#1  001C    D FARG#2  0018    D FARG#3  0014    D FARG#4  0010  
  D FARG#5  000C    D FARG#6  0008    D FARG#7  0004    D FARG#8  0000  
    R0      0000      R1      0001      R10     000A      R11     000B  
    R12     000C      R13     000D      R14     000E      R15     000F  
    R2      0002      R3      0003      R4      0004      R5      0005  
    R6      0006      R7      0007      R8      0008      R9      0009  
  0000 ERRORS

 Xa99 Cross Assembler
FNCARG 24/03/2007                                            PAGE 0003
  SEGMENT RORG     SIZE 00040 (>0028) BYTES
