/* Include file for L3FIOG file library */

extern fopen(),fclose(),fread(),fwrite();
extern fstat(),feof(),fseek(),fdel(),fload(),fsave();
extern mkdir(),attrib(),rename(),rendir();
extern adifil(),adofil();

/* File Type  */
#define SEQUENTIAL 0
#define RELATIVE   1

/* Record Type */
#define FIXED      0
#define VARIABLE   16

/* Data Type */
#define DISPLAY    0
#define INTERNAL   8
#define PROGRAM    0

/* Mode of Operation */
#define UPDATE     0
#define OUTPUT     2
#define INPUT      4
#define APPEND     6

/* read relative file sequentially. use */
/* this in place of  the record number  */
#define RELSEQ    -1

#asm
SEQUEN EQU 0
RELATI EQU 1
FIXED  EQU 0
VARIAB EQU 16
DISPLA EQU 0
INTERN EQU 8
PROGRA EQU 0
UPDATE EQU 0
OUTPUT EQU 2
INPUT  EQU 4
APPEND EQU 6
RELSEQ EQU -1
#endasm
