
 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0001
  0001            *c99 m-optimizer v1.1/g
  0002            *c99 f-optimizer v1.3/g
  0003             REF FARG#1,FARG#2,FARG#3,FARG#4,FARG#5,FARG#6,FARG#7,FARG#8
  0004            *c99 x-optimizer v1.4/g
  0005             REF XPOLL,XGETS,XPUTC,XPUTS,XDPUTS
  0006             REF XLOCAT,XTSCRN
  0007             REF XMSET,XMMOV,XMCPY,XSLEN,XSCHR
  0008             REF XSCAT,XSCPY,XSNCPY,XSCMP,XSNCMP
  0009             REF XVWTR,XVSBW,XVMBR,XVMBW
  0010            *c99 optimizer v4.5/g
  0011            *c99 v4.0 (c) 1985, 1987 Clint Pulley
  0012             REF C$CIND,C$DIV,C$REM,C$ASR,C$ASL,C$EQ,C$NE,C$LT,C$LE
  0013             REF C$GT,C$GE,C$ULT,C$ULE,C$UGT,C$UGE,C$LNEG,C$SWCH
  0014             REF GETCHA,GETS,PUTCHA,PUTS,LOCATE,POLL,TSCRN,EXIT,C$CALL
  0015            */*
  0016            * * PICALC1 V1.0 09/08/2007
  0017            * *
  0018            * * F.G.Kaal
  0019            * * De Dadelboom 81
  0020            * * 1911 KK Uitgeest
  0021            * *
  0022            * * Adapted from the Extended basic program
  0023            * * PiCalc by Walid Maalouli
  0024            * *
  0025            * * Remarks:
  0026            * * 1)Number of decimals that fit in a 32bit number is
  0027            * *   INT( LOG(SQR(2^31)) / LOG(10)) = 4
  0028            * *
  0029            * * 2)TI/EX Basic INT() function:
  0030            * *   INT(3.2)=3, INT(-3.2)=-4, INT(-0.2)=-1
  0031            * *
  0032            * * 3) Some magic numbers explained
  0033            * *    Number of decimals per long value is 4
  0034            * *    Therefore max number of decimals is 4*arraysize-2*4
  0035            * *    =4*652-8=2600
  0036            * *    PI=16*ATAN(1/5) - 4*ATAN(1/239)
  0037            * *    1/5 = 0.2000, the number 2000 is exactly that in 4 de
  0038            * *    25=5^2 and 57121=239^2
  0039            * * 
  0040            * */
  0041            *#include ".\..\TILIB\CGLOB_H"
  0042            */*
  0043            * * cglob_h
  0044            * *
  0045            * * These are the multipurpose global variables for C99C
  0046            * */
  0047            *
  0048            *extern errno, cnull;
  0049             REF ERRNO
  0050             REF CNULL
  0051            *
  0052            *
  0053            *#include ".\..\TILIB\MISC_H"
  0054            */* Functions in MISC */
  0055            *extern memset(),memmove(),memcpy(),memcmp();
  0056             REF MEMSET
  0057             REF MEMMOV
  0058             REF MEMCPY
  0059             REF MEMCMP

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0002
  0060            *extern strcpy(),strncpy(),strlen(),strcat();
  0061             REF STRCPY
  0062             REF STRNCP
  0063             REF STRLEN
  0064             REF STRCAT
  0065            *extern strcmp(),strncmp(),strchr();
  0066             REF STRCMP
  0067             REF STRNCM
  0068             REF STRCHR
  0069            *
  0070            *#include ".\..\TILIB\CONV_H"
  0071            */* CONV */
  0072            *
  0073            *extern xtol(),xtoi(),xctoi(),atol(),atoi();
  0074             REF XTOL
  0075             REF XTOI
  0076             REF XCTOI
  0077             REF ATOL
  0078             REF ATOI
  0079            *
  0080            *
  0081            *#include ".\..\TILIB\CTYPE_H"
  0082            *extern isalpha(),isupper(),islower(),isdigit(),isxdigit();
  0083             REF ISALPH
  0084             REF ISUPPE
  0085             REF ISLOWE
  0086             REF ISDIGI
  0087             REF ISXDIG
  0088            *extern isspace(),iscntrl(),ispunct(),isalnum(),isprint();
  0089             REF ISSPAC
  0090             REF ISCNTR
  0091             REF ISPUNC
  0092             REF ISALNU
  0093             REF ISPRIN
  0094            *extern isgraph(),toupper(),tolower(),ctype();
  0095             REF ISGRAP
  0096             REF TOUPPE
  0097             REF TOLOWE
  0098             REF CTYPE
  0099            *
  0100            */* types to use with getyxts() */
  0101            *
  0102            *#define CT_CNTRL  0x0001  /* 0-31 127 */
  0103            *#define CT_SPACE  0x0002  /* ' ' '\t' '\v' '\f' '\r' '\n' *
  0104            *#define CT_PUNCT  0x0004  /* not upper,lower,digit,xdigit,s
  0105            *#define CT_UPPER  0x0008  /* 'A'-'Z' */
  0106            *#define CT_LOWER  0x0010  /* 'a'-'z' */
  0107            *#define CT_ALPHA  0x0018  /* upper | lower */
  0108            *#define CT_ALNUM  0x0038  /* upper | lower | digit */
  0109            *#define CT_DIGIT  0x0020  /* '0'-'9' */
  0110            *#define CT_XDIGIT 0x0040  /* '0'-'9' | 'a'-'f' | 'A'-'F' */
  0111            *#define CT_PRINT  0x0080  /* ' '-'~' */
  0112            *#define CT_GRAPH  0x003C  /* alpha | digit | punct */
  0113            *#define LT_PRINT  0x0080  /* tolower(isprint())  in getyxts
  0114            *#define LT_GRAPH  0x403C  /* tolower(isgraph())  in getyxts
  0115            *#define LT_XDIGIT 0x4040  /* tolower(isxdigit()) in getyxts
  0116            *#define UT_PRINT  0x0080  /* toupper(isprint())  in getyxts
  0117            *#define UT_GRAPH  0x803C  /* toupper(isgraph())  in getyxts
  0118            *#define UT_XDIGIT 0x8040  /* toupper(isxdigit()) in getyxts

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0003
  0119            *
  0120            *#include ".\..\TILIB\LONG_H"
  0121            */* LONG */
  0122            *
  0123            *extern lclr(),  lseto(),linc(), ldec(), linv(),labs(),lneg(
  0124             REF LCLR
  0125             REF LSETO
  0126             REF LINC
  0127             REF LDEC
  0128             REF LINV
  0129             REF LABS
  0130             REF LNEG
  0131            *extern lcpys(), lcpyl(),lcmpl(),ltst();
  0132             REF LCPYS
  0133             REF LCPYL
  0134             REF LCMPL
  0135             REF LTST
  0136            *extern landl(), lorl(), lxorl(),lshls(),lshrs();
  0137             REF LANDL
  0138             REF LORL
  0139             REF LXORL
  0140             REF LSHLS
  0141             REF LSHRS
  0142            *extern ladds(), laddl(),lsubs(),lsubl();
  0143             REF LADDS
  0144             REF LADDL
  0145             REF LSUBS
  0146             REF LSUBL
  0147            *extern lmpys(), lmpyl();
  0148             REF LMPYS
  0149             REF LMPYL
  0150            *extern  sldivs(),ldivs(),lmods(),ldivl(),lmodl();
  0151             REF SLDIVS
  0152             REF LDIVS
  0153             REF LMODS
  0154             REF LDIVL
  0155             REF LMODL
  0156            *#include ".\..\TILIB\SPRINTF_H"
  0157            *extern dprintf(),printf(),sprintf();
  0158             REF DPRINT
  0159             REF PRINTF
  0160             REF SPRINT
  0161            *#include "PICALC_H"
  0162            */*
  0163            * * PICALC_H  V1.0 09/08/2007
  0164            * *
  0165            * * F.G.Kaal
  0166            * * De Dadelboom 81
  0167            * * 1911 KK Uitgeest
  0168            * *
  0169            * * Externals, Variables and definitions
  0170            * */
  0171            *
  0172            *#asm
  0173             REF VDPWD,VSBW,VMBW,VSBR,VMBR
  0174             REF GRMRA,GRMWA
  0175             REF THSCRU,LSTCRU
  0176             REF C$VADR,S$LOC
  0177            *

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0004
  0178            *#define MAXLINE 81
  0179            *#define MAXPATH 50
  0180            *
  0181            *extern int  KBARDL,KBARSP;
  0182             REF KBARDL
  0183             REF KBARSP
  0184            *
  0185            *extern getyxts(),getkey(),waitkey(),clearw();
  0186             REF GETYXT
  0187             REF GETKEY
  0188             REF WAITKE
  0189             REF CLEARW
  0190            *
  0191            *entry SUM,SUM1,TERM,TEMP;
  0192             DEF SUM
  0193             DEF SUM1
  0194             DEF TERM
  0195             DEF TEMP
  0196            *
  0197            *#define SIGNED 1 /* SIGNED OR UNSIGNED MPY AND DIV */
  0198            *
  0199            *#ifdef SIGNED
  0200            *#define LMPY lsmpyl
  0201            *#define LDIV lsdivl
  0202            *#endif
  0203            *
  0204            *#ifdef UNSIGNED
  0205            *#define LMPY lmpyl
  0206            *#define LDIV ldivl
  0207            *#endif
  0208            *
  0209            *#define LONGSIZE 4
  0210            *#define ARRSIZE  652
  0211            *
  0212            *char inpline[40];
  0213 0000       INPLIN BSS 40
  0214             EVEN
  0215            *int N,I,D,S,ITR,DENOM1,TBASE,MULT,FLAG;
  0216 0028       N BSS 2
  0217 002A       I BSS 2
  0218 002C       D BSS 2
  0219 002E       S BSS 2
  0220 0030       ITR BSS 2
  0221 0032       DENOM1 BSS 2
  0222 0034       TBASE BSS 2
  0223 0036       MULT BSS 2
  0224 0038       FLAG BSS 2
  0225            *int CPYBYTES;
  0226 003A       CPYBYT BSS 2
  0227            *
  0228            */* long variables */
  0229            *int L10000[2]  = {0x0000, 0x2710};
  0230            L10000
  0231 003C 0000   DATA 0,10000
       003E 2710 
  0232            *int L0[2]      = {0x0000, 0x0000};
  0233            L0
  0234 0040 0000   DATA 0,0
       0042 0000 

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0005
  0235            *
  0236            *int SUM[ARRSIZE][2],SUM1[ARRSIZE][2];
  0237 0044       SUM BSS 2608
  0238 0A74       SUM1 BSS 2608
  0239            *int TERM[ARRSIZE][2],TEMP[ARRSIZE][2];
  0240 14A4       TERM BSS 2608
  0241 1ED4       TEMP BSS 2608
  0242            *
  0243            *int lval[2]; 
  0244 2904       LVAL BSS 4
  0245            *int DIVIDEND[2], REMAINDER[2], LDENOM[2];
  0246 2908       DIVIDE BSS 4
  0247 290C       REMAIN BSS 4
  0248 2910       LDENOM BSS 4
  0249            *int QUOTIENT[2];
  0250 2914       QUOTIE BSS 4
  0251            *char *lp1,*lp2;
  0252 2918 0000  LP1 DATA 0
  0253             EVEN
  0254 291A 0000  LP2 DATA 0
  0255             EVEN
  0256            *
  0257            *main()
  0258             DEF MAIN
  0259            MAIN
  0260            *{
  0261            *    locate(1,8); puts("Pi Calculator");
  0262 291C 0201   LI 1,1
       291E 0001 
  0263 2920 0200   LI 0,8
       2922 0008 
  0264 2924 069C   BL *12
  0265 2926 0000   DATA XLOCAT
  0266 2928 0205   LI 5,C$3
       292A 2B76'
  0267 292C 069C   BL *12
  0268 292E 0000   DATA XPUTS
  0269            *    locate(3,8); puts("By Walid Maalouli");
  0270 2930 0201   LI 1,3
       2932 0003 
  0271 2934 0200   LI 0,8
       2936 0008 
  0272 2938 069C   BL *12
  0273 293A 2926'  DATA XLOCAT
  0274 293C 0205   LI 5,C$3+14
       293E 2B84'
  0275 2940 069C   BL *12
  0276 2942 292E'  DATA XPUTS
  0277            *    locate(5,8); puts("August 2007");
  0278 2944 0201   LI 1,5
       2946 0005 
  0279 2948 0200   LI 0,8
       294A 0008 
  0280 294C 069C   BL *12
  0281 294E 293A'  DATA XLOCAT
  0282 2950 0205   LI 5,C$3+32
       2952 2B96'
  0283 2954 069C   BL *12
  0284 2956 2942'  DATA XPUTS

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0006
  0285            *    locate(7,8); puts("Converted to C99");
  0286 2958 0201   LI 1,7
       295A 0007 
  0287 295C 0200   LI 0,8
       295E 0008 
  0288 2960 069C   BL *12
  0289 2962 294E'  DATA XLOCAT
  0290 2964 0205   LI 5,C$3+44
       2966 2BA2'
  0291 2968 069C   BL *12
  0292 296A 2956'  DATA XPUTS
  0293            *    locate(9,8); puts("By Fred G. Kaal");
  0294 296C 0201   LI 1,9
       296E 0009 
  0295 2970 0200   LI 0,8
       2972 0008 
  0296 2974 069C   BL *12
  0297 2976 2962'  DATA XLOCAT
  0298 2978 0205   LI 5,C$3+61
       297A 2BB3'
  0299 297C 069C   BL *12
  0300 297E 296A'  DATA XPUTS
  0301            *
  0302            *    memset(SUM ,0,ARRSIZE*LONGSIZE);
  0303 2980 0208   LI 8,SUM
       2982 0044'
  0304 2984 068F   BL 15
  0305 2986 6208   S 8,8
  0306 2988 068F   BL 15
  0307 298A 0208   LI 8,652
       298C 028C 
  0308 298E 068F   BL 15
  0309 2990 0208   LI 8,4
       2992 0004 
  0310 2994 3A3E   MPY *14+,8
  0311 2996 C209   MOV 9,8
  0312 2998 068F   BL 15
  0313 299A 069C   BL *12
  0314 299C 0000   DATA MEMSET
  0315 299E 022E   AI 14,6
       29A0 0006 
  0316            *    memset(SUM1,0,ARRSIZE*LONGSIZE);
  0317 29A2 0208   LI 8,SUM1
       29A4 0A74'
  0318 29A6 068F   BL 15
  0319 29A8 6208   S 8,8
  0320 29AA 068F   BL 15
  0321 29AC 0208   LI 8,652
       29AE 028C 
  0322 29B0 068F   BL 15
  0323 29B2 0208   LI 8,4
       29B4 0004 
  0324 29B6 3A3E   MPY *14+,8
  0325 29B8 C209   MOV 9,8
  0326 29BA 068F   BL 15
  0327 29BC 069C   BL *12
  0328 29BE 299C'  DATA MEMSET
  0329 29C0 022E   AI 14,6
       29C2 0006 

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0007
  0330            *    memset(TERM,0,ARRSIZE*LONGSIZE);
  0331 29C4 0208   LI 8,TERM
       29C6 14A4'
  0332 29C8 068F   BL 15
  0333 29CA 6208   S 8,8
  0334 29CC 068F   BL 15
  0335 29CE 0208   LI 8,652
       29D0 028C 
  0336 29D2 068F   BL 15
  0337 29D4 0208   LI 8,4
       29D6 0004 
  0338 29D8 3A3E   MPY *14+,8
  0339 29DA C209   MOV 9,8
  0340 29DC 068F   BL 15
  0341 29DE 069C   BL *12
  0342 29E0 29BE'  DATA MEMSET
  0343 29E2 022E   AI 14,6
       29E4 0006 
  0344            *    memset(TEMP,0,ARRSIZE*LONGSIZE);
  0345 29E6 0208   LI 8,TEMP
       29E8 1ED4'
  0346 29EA 068F   BL 15
  0347 29EC 6208   S 8,8
  0348 29EE 068F   BL 15
  0349 29F0 0208   LI 8,652
       29F2 028C 
  0350 29F4 068F   BL 15
  0351 29F6 0208   LI 8,4
       29F8 0004 
  0352 29FA 3A3E   MPY *14+,8
  0353 29FC C209   MOV 9,8
  0354 29FE 068F   BL 15
  0355 2A00 069C   BL *12
  0356 2A02 29E0'  DATA MEMSET
  0357 2A04 022E   AI 14,6
       2A06 0006 
  0358            *    do
  0359            C$6
  0360            *    {
  0361            *        locate(12,2);  puts("# of decimals (mult. of 4)");
  0362 2A08 0201   LI 1,12
       2A0A 000C 
  0363 2A0C 0200   LI 0,2
       2A0E 0002 
  0364 2A10 069C   BL *12
  0365 2A12 2976'  DATA XLOCAT
  0366 2A14 0205   LI 5,C$3+77
       2A16 2BC3'
  0367 2A18 069C   BL *12
  0368 2A1A 297E'  DATA XPUTS
  0369            *        locate(13,2);  puts("(Maximum of 2600 decimals)");
  0370 2A1C 0201   LI 1,13
       2A1E 000D 
  0371 2A20 0200   LI 0,2
       2A22 0002 
  0372 2A24 069C   BL *12
  0373 2A26 2A12'  DATA XLOCAT
  0374 2A28 0205   LI 5,C$3+104
       2A2A 2BDE'

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0008
  0375 2A2C 069C   BL *12
  0376 2A2E 2A1A'  DATA XPUTS
  0377            *        getyxts(14,12,CT_DIGIT,4,inpline);
  0378 2A30 0204   LI 4,14
       2A32 000E 
  0379 2A34 0205   LI 5,12
       2A36 000C 
  0380 2A38 0206   LI 6,32
       2A3A 0020 
  0381 2A3C 0207   LI 7,4
       2A3E 0004 
  0382 2A40 0208   LI 8,INPLIN
       2A42 0000'
  0383 2A44 06A0   BL @FARG#5
       2A46 0000 
  0384 2A48 0000   DATA GETYXT
  0385 2A4A 022E   AI 14,10
       2A4C 000A 
  0386            *        D=atoi(inpline);
  0387 2A4E 0208   LI 8,INPLIN
       2A50 0000'
  0388 2A52 069C   BL *12
  0389 2A54 0000   DATA ATOI
  0390 2A56 C808   MOV 8,@D
       2A58 002C'
  0391            *    }
  0392            *    while ((D<=0) || (D>2600) || (D%4!=0));
  0393            C$4
  0394 2A5A C220   MOV @D,8
       2A5C 002C'
  0395 2A5E 0288   CI 8,0
       2A60 0000 
  0396 2A62 1110   JLT C$7
  0397 2A64 130F   JEQ C$7
  0398 2A66 C220   MOV @D,8
       2A68 002C'
  0399 2A6A 0288   CI 8,2600
       2A6C 0A28 
  0400 2A6E 150A   JGT C$7
  0401 2A70 C220   MOV @D,8
       2A72 002C'
  0402 2A74 068F   BL 15
  0403 2A76 0208   LI 8,4
       2A78 0004 
  0404 2A7A 06A0   BL @C$REM
       2A7C 0000 
  0405 2A7E 0288   CI 8,0
       2A80 0000 
  0406 2A82 1302   JEQ C$5
  0407            C$7
  0408 2A84 0460   B @C$6
       2A86 2A08'
  0409            C$5
  0410            *
  0411            */*160 ITR=INT(D/1.4) :: D=D/5+2 */
  0412            *    ITR=(D*10)/14+1; D=D/4+2;
  0413 2A88 C220   MOV @D,8
       2A8A 002C'
  0414 2A8C 068F   BL 15

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0009
  0415 2A8E 0208   LI 8,10
       2A90 000A 
  0416 2A92 3A3E   MPY *14+,8
  0417 2A94 C209   MOV 9,8
  0418 2A96 068F   BL 15
  0419 2A98 0208   LI 8,14
       2A9A 000E 
  0420 2A9C 06A0   BL @C$DIV
       2A9E 0000 
  0421 2AA0 0228   AI 8,1
       2AA2 0001 
  0422 2AA4 C808   MOV 8,@ITR
       2AA6 0030'
  0423 2AA8 C220   MOV @D,8
       2AAA 002C'
  0424 2AAC 068F   BL 15
  0425 2AAE 0208   LI 8,4
       2AB0 0004 
  0426 2AB2 06A0   BL @C$DIV
       2AB4 2A9E'
  0427 2AB6 0228   AI 8,2
       2AB8 0002 
  0428 2ABA C808   MOV 8,@D
       2ABC 002C'
  0429            *
  0430            */*170 SUM(1)=3 :: SUM(2)=20000 :: TERM(1)=0 :: TERM(2)=2000
  0431            *  :: S=0 :: DENOM1=3 :: TBASE=25 :: MULT=16*/
  0432            *
  0433            *    lcpys(&SUM[1][0],3);  lcpys(&SUM[2][0],2000);
  0434 2ABE 0208   LI 8,SUM
       2AC0 0044'
  0435 2AC2 068F   BL 15
  0436 2AC4 0208   LI 8,1
       2AC6 0001 
  0437 2AC8 0207   LI 7,2
       2ACA 0002 
  0438 2ACC 39C8   MPY 8,7
  0439 2ACE A208   A 8,8
  0440 2AD0 A23E   A *14+,8
  0441 2AD2 068F   BL 15
  0442 2AD4 0208   LI 8,3
       2AD6 0003 
  0443 2AD8 06A0   BL @FARG#1
       2ADA 0000 
  0444 2ADC 0000   DATA LCPYS
  0445 2ADE 022E   AI 14,4
       2AE0 0004 
  0446 2AE2 0208   LI 8,SUM
       2AE4 0044'
  0447 2AE6 068F   BL 15
  0448 2AE8 0208   LI 8,2
       2AEA 0002 
  0449 2AEC 0207   LI 7,2
       2AEE 0002 
  0450 2AF0 39C8   MPY 8,7
  0451 2AF2 A208   A 8,8
  0452 2AF4 A23E   A *14+,8
  0453 2AF6 068F   BL 15
  0454 2AF8 0208   LI 8,2000

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0010
       2AFA 07D0 
  0455 2AFC 06A0   BL @FARG#1
       2AFE 2ADA'
  0456 2B00 2ADC'  DATA LCPYS
  0457 2B02 022E   AI 14,4
       2B04 0004 
  0458            *    lcpys(&TERM[1][0],0); lcpys(&TERM[2][0],2000);
  0459 2B06 0208   LI 8,TERM
       2B08 14A4'
  0460 2B0A 068F   BL 15
  0461 2B0C 0208   LI 8,1
       2B0E 0001 
  0462 2B10 0207   LI 7,2
       2B12 0002 
  0463 2B14 39C8   MPY 8,7
  0464 2B16 A208   A 8,8
  0465 2B18 A23E   A *14+,8
  0466 2B1A 068F   BL 15
  0467 2B1C 6208   S 8,8
  0468 2B1E 06A0   BL @FARG#1
       2B20 2AFE'
  0469 2B22 2B00'  DATA LCPYS
  0470 2B24 022E   AI 14,4
       2B26 0004 
  0471 2B28 0208   LI 8,TERM
       2B2A 14A4'
  0472 2B2C 068F   BL 15
  0473 2B2E 0208   LI 8,2
       2B30 0002 
  0474 2B32 0207   LI 7,2
       2B34 0002 
  0475 2B36 39C8   MPY 8,7
  0476 2B38 A208   A 8,8
  0477 2B3A A23E   A *14+,8
  0478 2B3C 068F   BL 15
  0479 2B3E 0208   LI 8,2000
       2B40 07D0 
  0480 2B42 06A0   BL @FARG#1
       2B44 2B20'
  0481 2B46 2B22'  DATA LCPYS
  0482 2B48 022E   AI 14,4
       2B4A 0004 
  0483            *
  0484            *    CPYBYTES=D*LONGSIZE+LONGSIZE; /* Array size in bytes */
  0485 2B4C C220   MOV @D,8
       2B4E 002C'
  0486 2B50 068F   BL 15
  0487 2B52 0208   LI 8,4
       2B54 0004 
  0488 2B56 3A3E   MPY *14+,8
  0489 2B58 C209   MOV 9,8
  0490 2B5A 0228   AI 8,4
       2B5C 0004 
  0491 2B5E C808   MOV 8,@CPYBYT
       2B60 003A'
  0492            *
  0493            *    CalcPi();
  0494 2B62 069C   BL *12
  0495 2B64 2BFA'  DATA CALCPI

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0011
  0496            *    OutScreen();
  0497 2B66 069C   BL *12
  0498 2B68 319C'  DATA OUTSCR
  0499            *    
  0500            *    exit(0);
  0501 2B6A 6208   S 8,8
  0502 2B6C 06A0   BL @FARG#1
       2B6E 2B44'
  0503 2B70 0000   DATA EXIT
  0504 2B72 05CE   INCT 14
  0505            *}
  0506 2B74 045D   B *13
  0507 2B76   50  C$3 BYTE 80,105,32,67,97,108,99,117,108,97,116,111
       2B77   69 
       2B78   20 
       2B79   43 
       2B7A   61 
       2B7B   6C 
       2B7C   63 
       2B7D   75 
       2B7E   6C 
       2B7F   61 
       2B80   74 
       2B81   6F 
  0508 2B82   72   BYTE 114,0,66,121,32,87,97,108,105,100,32,77
       2B83   00 
       2B84   42 
       2B85   79 
       2B86   20 
       2B87   57 
       2B88   61 
       2B89   6C 
       2B8A   69 
       2B8B   64 
       2B8C   20 
       2B8D   4D 
  0509 2B8E   61   BYTE 97,97,108,111,117,108,105,0,65,117,103,117
       2B8F   61 
       2B90   6C 
       2B91   6F 
       2B92   75 
       2B93   6C 
       2B94   69 
       2B95   00 
       2B96   41 
       2B97   75 
       2B98   67 
       2B99   75 
  0510 2B9A   73   BYTE 115,116,32,50,48,48,55,0,67,111,110,118
       2B9B   74 
       2B9C   20 
       2B9D   32 
       2B9E   30 
       2B9F   30 
       2BA0   37 
       2BA1   00 
       2BA2   43 
       2BA3   6F 
       2BA4   6E 

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0012
       2BA5   76 
  0511 2BA6   65   BYTE 101,114,116,101,100,32,116,111,32,67,57,57
       2BA7   72 
       2BA8   74 
       2BA9   65 
       2BAA   64 
       2BAB   20 
       2BAC   74 
       2BAD   6F 
       2BAE   20 
       2BAF   43 
       2BB0   39 
       2BB1   39 
  0512 2BB2   00   BYTE 0,66,121,32,70,114,101,100,32,71,46,32
       2BB3   42 
       2BB4   79 
       2BB5   20 
       2BB6   46 
       2BB7   72 
       2BB8   65 
       2BB9   64 
       2BBA   20 
       2BBB   47 
       2BBC   2E 
       2BBD   20 
  0513 2BBE   4B   BYTE 75,97,97,108,0,35,32,111,102,32,100,101
       2BBF   61 
       2BC0   61 
       2BC1   6C 
       2BC2   00 
       2BC3   23 
       2BC4   20 
       2BC5   6F 
       2BC6   66 
       2BC7   20 
       2BC8   64 
       2BC9   65 
  0514 2BCA   63   BYTE 99,105,109,97,108,115,32,40,109,117,108,116
       2BCB   69 
       2BCC   6D 
       2BCD   61 
       2BCE   6C 
       2BCF   73 
       2BD0   20 
       2BD1   28 
       2BD2   6D 
       2BD3   75 
       2BD4   6C 
       2BD5   74 
  0515 2BD6   2E   BYTE 46,32,111,102,32,52,41,0,40,77,97,120
       2BD7   20 
       2BD8   6F 
       2BD9   66 
       2BDA   20 
       2BDB   34 
       2BDC   29 
       2BDD   00 
       2BDE   28 
       2BDF   4D 

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0013
       2BE0   61 
       2BE1   78 
  0516 2BE2   69   BYTE 105,109,117,109,32,111,102,32,50,54,48,48
       2BE3   6D 
       2BE4   75 
       2BE5   6D 
       2BE6   20 
       2BE7   6F 
       2BE8   66 
       2BE9   20 
       2BEA   32 
       2BEB   36 
       2BEC   30 
       2BED   30 
  0517 2BEE   20   BYTE 32,100,101,99,105,109,97,108,115,41,0
       2BEF   64 
       2BF0   65 
       2BF1   63 
       2BF2   69 
       2BF3   6D 
       2BF4   61 
       2BF5   6C 
       2BF6   73 
       2BF7   29 
       2BF8   00 
  0518             EVEN
  0519            *
  0520            *CalcPi()
  0521            CALCPI
  0522            *{
  0523            */*170*/ DENOM1=3; TBASE=25; MULT=16; FLAG=0;
  0524 2BFA 0208   LI 8,3
       2BFC 0003 
  0525 2BFE C808   MOV 8,@DENOM1
       2C00 0032'
  0526 2C02 0208   LI 8,25
       2C04 0019 
  0527 2C06 C808   MOV 8,@TBASE
       2C08 0034'
  0528 2C0A 0208   LI 8,16
       2C0C 0010 
  0529 2C0E C808   MOV 8,@MULT
       2C10 0036'
  0530 2C12 6208   S 8,8
  0531 2C14 C808   MOV 8,@FLAG
       2C16 0038'
  0532            */*180*/ Iterate();
  0533 2C18 069C   BL *12
  0534 2C1A 2DB8'  DATA ITERAT
  0535            *
  0536            */*460 IF FLAG=1 THEN 620*/
  0537            */*470*/ DENOM1=3; TBASE=57121; MULT=4;
  0538 2C1C 0208   LI 8,3
       2C1E 0003 
  0539 2C20 C808   MOV 8,@DENOM1
       2C22 0032'
  0540 2C24 0208   LI 8,57121
       2C26 DF21 
  0541 2C28 C808   MOV 8,@TBASE

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0014
       2C2A 0034'
  0542 2C2C 0208   LI 8,4
       2C2E 0004 
  0543 2C30 C808   MOV 8,@MULT
       2C32 0036'
  0544            *            
  0545            */*480 FOR I=1 TO D*/
  0546            */*490 SUM1(I)=SUM(I)*/
  0547            */*500 SUM(I)=0 :: TERM(I)=0*/
  0548            */*510 NEXT I*/
  0549            *    memcpy(SUM1,SUM,CPYBYTES);
  0550 2C34 0200   LI 0,SUM1
       2C36 0A74'
  0551 2C38 0201   LI 1,SUM
       2C3A 0044'
  0552 2C3C C0A0   MOV @CPYBYT,2
       2C3E 003A'
  0553 2C40 069C   BL *12
  0554 2C42 0000   DATA XMCPY
  0555            *    memset(SUM,  0, CPYBYTES);
  0556 2C44 0206   LI 6,SUM
       2C46 0044'
  0557 2C48 61C7   S 7,7
  0558 2C4A C220   MOV @CPYBYT,8
       2C4C 003A'
  0559 2C4E 06A0   BL @FARG#3
       2C50 0000 
  0560 2C52 2A02'  DATA MEMSET
  0561 2C54 022E   AI 14,6
       2C56 0006 
  0562            *    memset(TERM, 0, CPYBYTES);
  0563 2C58 0206   LI 6,TERM
       2C5A 14A4'
  0564 2C5C 61C7   S 7,7
  0565 2C5E C220   MOV @CPYBYT,8
       2C60 003A'
  0566 2C62 06A0   BL @FARG#3
       2C64 2C50'
  0567 2C66 2C52'  DATA MEMSET
  0568 2C68 022E   AI 14,6
       2C6A 0006 
  0569            *
  0570            */*520 TERM(1)=4*/
  0571            *    lcpys(&TERM[1][0],4);
  0572 2C6C 0208   LI 8,TERM
       2C6E 14A4'
  0573 2C70 068F   BL 15
  0574 2C72 0208   LI 8,1
       2C74 0001 
  0575 2C76 0207   LI 7,2
       2C78 0002 
  0576 2C7A 39C8   MPY 8,7
  0577 2C7C A208   A 8,8
  0578 2C7E A23E   A *14+,8
  0579 2C80 068F   BL 15
  0580 2C82 0208   LI 8,4
       2C84 0004 
  0581 2C86 06A0   BL @FARG#1
       2C88 2B6E'

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0015
  0582 2C8A 2B46'  DATA LCPYS
  0583 2C8C 022E   AI 14,4
       2C8E 0004 
  0584            *
  0585            */*530 DENOM=239 :: REMAINDER=0*/
  0586            */*540 GOSUB 1050*/
  0587            *    SubDivide(239);
  0588 2C90 0208   LI 8,239
       2C92 00EF 
  0589 2C94 06A0   BL @FARG#1
       2C96 2C88'
  0590 2C98 306A'  DATA SUBDIV
  0591 2C9A 05CE   INCT 14
  0592            *
  0593            */*550 FOR I=1 TO D*/
  0594            */*560 SUM(I)=TERM(I) :: TERM(I)=0*/
  0595            */*570 NEXT I*/
  0596            *    memcpy(SUM,TERM,CPYBYTES);
  0597 2C9C 0200   LI 0,SUM
       2C9E 0044'
  0598 2CA0 0201   LI 1,TERM
       2CA2 14A4'
  0599 2CA4 C0A0   MOV @CPYBYT,2
       2CA6 003A'
  0600 2CA8 069C   BL *12
  0601 2CAA 2C42'  DATA XMCPY
  0602            *    memset(TERM, 0, CPYBYTES);
  0603 2CAC 0206   LI 6,TERM
       2CAE 14A4'
  0604 2CB0 61C7   S 7,7
  0605 2CB2 C220   MOV @CPYBYT,8
       2CB4 003A'
  0606 2CB6 06A0   BL @FARG#3
       2CB8 2C64'
  0607 2CBA 2C66'  DATA MEMSET
  0608 2CBC 022E   AI 14,6
       2CBE 0006 
  0609            *
  0610            */*580 DENOM=239 :: TERM(1)=1 :: REMAINDER=0*/
  0611            */*590 GOSUB 1050*/
  0612            *    lcpys(&TERM[1][0],1);
  0613 2CC0 0208   LI 8,TERM
       2CC2 14A4'
  0614 2CC4 068F   BL 15
  0615 2CC6 0208   LI 8,1
       2CC8 0001 
  0616 2CCA 0207   LI 7,2
       2CCC 0002 
  0617 2CCE 39C8   MPY 8,7
  0618 2CD0 A208   A 8,8
  0619 2CD2 A23E   A *14+,8
  0620 2CD4 068F   BL 15
  0621 2CD6 0208   LI 8,1
       2CD8 0001 
  0622 2CDA 06A0   BL @FARG#1
       2CDC 2C96'
  0623 2CDE 2C8A'  DATA LCPYS
  0624 2CE0 022E   AI 14,4
       2CE2 0004 

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0016
  0625            *    SubDivide(239);
  0626 2CE4 0208   LI 8,239
       2CE6 00EF 
  0627 2CE8 06A0   BL @FARG#1
       2CEA 2CDC'
  0628 2CEC 306A'  DATA SUBDIV
  0629 2CEE 05CE   INCT 14
  0630            *
  0631            */*600 FLAG=1 :: S=0*/
  0632            */*610 GOTO 180*/
  0633            *    Iterate();
  0634 2CF0 069C   BL *12
  0635 2CF2 2DB8'  DATA ITERAT
  0636            *
  0637            */*620 PRINT :: PRINT "Finalizing calculations..." :: PRINT*
  0638            *    puts("\nFinalizing calculations...\n\n");
  0639 2CF4 0205   LI 5,C$8
       2CF6 2D9A'
  0640 2CF8 069C   BL *12
  0641 2CFA 2A2E'  DATA XPUTS
  0642            *
  0643            */*630 FOR I=1 TO D*/
  0644            *    lp1=&SUM[1][0]; lp2=&SUM1[1][0];
  0645 2CFC 0208   LI 8,SUM
       2CFE 0044'
  0646 2D00 068F   BL 15
  0647 2D02 0208   LI 8,1
       2D04 0001 
  0648 2D06 0207   LI 7,2
       2D08 0002 
  0649 2D0A 39C8   MPY 8,7
  0650 2D0C A208   A 8,8
  0651 2D0E A23E   A *14+,8
  0652 2D10 C808   MOV 8,@LP1
       2D12 2918'
  0653 2D14 0208   LI 8,SUM1
       2D16 0A74'
  0654 2D18 068F   BL 15
  0655 2D1A 0208   LI 8,1
       2D1C 0001 
  0656 2D1E 0207   LI 7,2
       2D20 0002 
  0657 2D22 39C8   MPY 8,7
  0658 2D24 A208   A 8,8
  0659 2D26 A23E   A *14+,8
  0660 2D28 C808   MOV 8,@LP2
       2D2A 291A'
  0661            *    for (I=1; I<=D; ++I)
  0662 2D2C 0208   LI 8,1
       2D2E 0001 
  0663 2D30 C808   MOV 8,@I
       2D32 002A'
  0664            C$11
  0665 2D34 C220   MOV @I,8
       2D36 002A'
  0666 2D38 8808   C 8,@D
       2D3A 002C'
  0667 2D3C 1103   JLT $+8
  0668 2D3E 1302   JEQ $+6

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0017
  0669 2D40 0460   B @C$10
       2D42 2D94'
  0670 2D44 0460   B @C$12
       2D46 2D54'
  0671            C$9
  0672 2D48 05A0   INC @I
       2D4A 002A'
  0673 2D4C C220   MOV @I,8
       2D4E 002A'
  0674 2D50 0460   B @C$11
       2D52 2D34'
  0675            C$12
  0676            *    {
  0677            */*640 SUM1(I)=SUM1(I)-SUM(I) :: SUM(I)=SUM1(I)*/
  0678            *        lsubl(lp2,lp1); lcpyl(lp1,lp2);
  0679 2D54 C1E0   MOV @LP2,7
       2D56 291A'
  0680 2D58 C220   MOV @LP1,8
       2D5A 2918'
  0681 2D5C 06A0   BL @FARG#2
       2D5E 0000 
  0682 2D60 0000   DATA LSUBL
  0683 2D62 022E   AI 14,4
       2D64 0004 
  0684 2D66 C1E0   MOV @LP1,7
       2D68 2918'
  0685 2D6A C220   MOV @LP2,8
       2D6C 291A'
  0686 2D6E 06A0   BL @FARG#2
       2D70 2D5E'
  0687 2D72 0000   DATA LCPYL
  0688 2D74 022E   AI 14,4
       2D76 0004 
  0689            *        lp1=lp1+LONGSIZE; lp2=lp2+LONGSIZE;
  0690 2D78 C220   MOV @LP1,8
       2D7A 2918'
  0691 2D7C 0228   AI 8,4
       2D7E 0004 
  0692 2D80 C808   MOV 8,@LP1
       2D82 2918'
  0693 2D84 C220   MOV @LP2,8
       2D86 291A'
  0694 2D88 0228   AI 8,4
       2D8A 0004 
  0695 2D8C C808   MOV 8,@LP2
       2D8E 291A'
  0696            */*650 NEXT I*/
  0697            *    }
  0698 2D90 0460   B @C$9
       2D92 2D48'
  0699            C$10
  0700            *
  0701            */*660 FLAG=2*/
  0702            */*670 GOTO 330*/
  0703            *    DoCarry();
  0704 2D94 069C   BL *12
  0705 2D96 2F5A'  DATA DOCARR
  0706            */*680 ready!*/
  0707            *}

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0018
  0708 2D98 045D   B *13
  0709 2D9A   0A  C$8 BYTE 10,70,105,110,97,108,105,122,105,110,103,32
       2D9B   46 
       2D9C   69 
       2D9D   6E 
       2D9E   61 
       2D9F   6C 
       2DA0   69 
       2DA1   7A 
       2DA2   69 
       2DA3   6E 
       2DA4   67 
       2DA5   20 
  0710 2DA6   63   BYTE 99,97,108,99,117,108,97,116,105,111,110,115
       2DA7   61 
       2DA8   6C 
       2DA9   63 
       2DAA   75 
       2DAB   6C 
       2DAC   61 
       2DAD   74 
       2DAE   69 
       2DAF   6F 
       2DB0   6E 
       2DB1   73 
  0711 2DB2   2E   BYTE 46,46,46,10,10,0
       2DB3   2E 
       2DB4   2E 
       2DB5   0A 
       2DB6   0A 
       2DB7   00 
  0712             EVEN
  0713            *
  0714            *Iterate()
  0715            ITERAT
  0716            *{
  0717            *    FLAG=FLAG+1; S=0;
  0718 2DB8 C220   MOV @FLAG,8
       2DBA 0038'
  0719 2DBC 0228   AI 8,1
       2DBE 0001 
  0720 2DC0 C808   MOV 8,@FLAG
       2DC2 0038'
  0721 2DC4 6208   S 8,8
  0722 2DC6 C808   MOV 8,@S
       2DC8 002E'
  0723            *   
  0724            */*180 FOR N=1 TO ITR+1*/
  0725            *    for (N=1; N<=ITR; ++N)
  0726 2DCA 0208   LI 8,1
       2DCC 0001 
  0727 2DCE C808   MOV 8,@N
       2DD0 0028'
  0728            C$16
  0729 2DD2 C220   MOV @N,8
       2DD4 0028'
  0730 2DD6 8808   C 8,@ITR
       2DD8 0030'
  0731 2DDA 1103   JLT $+8

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0019
  0732 2DDC 1302   JEQ $+6
  0733 2DDE 0460   B @C$15
       2DE0 2F40'
  0734 2DE2 0460   B @C$17
       2DE4 2DF2'
  0735            C$14
  0736 2DE6 05A0   INC @N
       2DE8 0028'
  0737 2DEA C220   MOV @N,8
       2DEC 0028'
  0738 2DEE 0460   B @C$16
       2DF0 2DD2'
  0739            C$17
  0740            *    {
  0741            */*190 IF FLAG=0 THEN PRINT "Term 1 iteration #";N ELSE PRIN
  0742            
  0743            
  0744            
  0745            
  0746            *#";N*/
  0747            *        printf("Term %u iteration #%u\n", FLAG, N);
  0748 2DF2 0206   LI 6,C$13
       2DF4 2F42'
  0749 2DF6 C1E0   MOV @FLAG,7
       2DF8 0038'
  0750 2DFA C220   MOV @N,8
       2DFC 0028'
  0751 2DFE 06A0   BL @FARG#3
       2E00 2CB8'
  0752 2E02 0000   DATA PRINTF
  0753 2E04 022E   AI 14,6
       2E06 0006 
  0754            *
  0755            */*200 IF N=1 THEN 220*/
  0756            */*210 FOR I=1 TO D :: TERM(I)=TEMP(I) :: NEXT I*/
  0757            *        if (N!=1) memcpy(TERM, TEMP, CPYBYTES);
  0758 2E08 C220   MOV @N,8
       2E0A 0028'
  0759 2E0C 0288   CI 8,1
       2E0E 0001 
  0760 2E10 1308   JEQ C$18
  0761 2E12 0200   LI 0,TERM
       2E14 14A4'
  0762 2E16 0201   LI 1,TEMP
       2E18 1ED4'
  0763 2E1A C0A0   MOV @CPYBYT,2
       2E1C 003A'
  0764 2E1E 069C   BL *12
  0765 2E20 2CAA'  DATA XMCPY
  0766            *            
  0767            */*220 DENOM=TBASE :: REMAINDER=0*/
  0768            */*230 GOSUB 1050*/
  0769            *        SubDivide(TBASE);
  0770            C$18
  0771 2E22 C220   MOV @TBASE,8
       2E24 0034'
  0772 2E26 06A0   BL @FARG#1
       2E28 2CEA'
  0773 2E2A 306A'  DATA SUBDIV

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0020
  0774 2E2C 05CE   INCT 14
  0775            *
  0776            */*240 FOR I=1 TO D :: TEMP(I)=TERM(I) :: NEXT I*/
  0777            *        memcpy(TEMP, TERM, CPYBYTES);
  0778 2E2E 0200   LI 0,TEMP
       2E30 1ED4'
  0779 2E32 0201   LI 1,TERM
       2E34 14A4'
  0780 2E36 C0A0   MOV @CPYBYT,2
       2E38 003A'
  0781 2E3A 069C   BL *12
  0782 2E3C 2E20'  DATA XMCPY
  0783            *
  0784            */*250 DENOM=DENOM1 :: REMAINDER=0*/
  0785            */*260 GOSUB 1050*/
  0786            *        SubDivide(DENOM1);
  0787 2E3E C220   MOV @DENOM1,8
       2E40 0032'
  0788 2E42 06A0   BL @FARG#1
       2E44 2E28'
  0789 2E46 306A'  DATA SUBDIV
  0790 2E48 05CE   INCT 14
  0791            *
  0792            */*270 FOR I=1 TO D*/
  0793            *        lp1=&SUM[1][0]; lp2=&TERM[1][0];
  0794 2E4A 0208   LI 8,SUM
       2E4C 0044'
  0795 2E4E 068F   BL 15
  0796 2E50 0208   LI 8,1
       2E52 0001 
  0797 2E54 0207   LI 7,2
       2E56 0002 
  0798 2E58 39C8   MPY 8,7
  0799 2E5A A208   A 8,8
  0800 2E5C A23E   A *14+,8
  0801 2E5E C808   MOV 8,@LP1
       2E60 2918'
  0802 2E62 0208   LI 8,TERM
       2E64 14A4'
  0803 2E66 068F   BL 15
  0804 2E68 0208   LI 8,1
       2E6A 0001 
  0805 2E6C 0207   LI 7,2
       2E6E 0002 
  0806 2E70 39C8   MPY 8,7
  0807 2E72 A208   A 8,8
  0808 2E74 A23E   A *14+,8
  0809 2E76 C808   MOV 8,@LP2
       2E78 291A'
  0810            *        for (I=1; I<=D; ++I)
  0811 2E7A 0208   LI 8,1
       2E7C 0001 
  0812 2E7E C808   MOV 8,@I
       2E80 002A'
  0813            C$21
  0814 2E82 C220   MOV @I,8
       2E84 002A'
  0815 2E86 8808   C 8,@D
       2E88 002C'

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0021
  0816 2E8A 1103   JLT $+8
  0817 2E8C 1302   JEQ $+6
  0818 2E8E 0460   B @C$20
       2E90 2F14'
  0819 2E92 0460   B @C$22
       2E94 2EA2'
  0820            C$19
  0821 2E96 05A0   INC @I
       2E98 002A'
  0822 2E9A C220   MOV @I,8
       2E9C 002A'
  0823 2E9E 0460   B @C$21
       2EA0 2E82'
  0824            C$22
  0825            *        {
  0826            */*280 IF S=0 THEN 300*/
  0827            *            lcpys(lval,MULT);
  0828 2EA2 0207   LI 7,LVAL
       2EA4 2904'
  0829 2EA6 C220   MOV @MULT,8
       2EA8 0036'
  0830 2EAA 06A0   BL @FARG#2
       2EAC 2D70'
  0831 2EAE 2CDE'  DATA LCPYS
  0832 2EB0 022E   AI 14,4
       2EB2 0004 
  0833            *            LMPY(lval,lp2);
  0834 2EB4 0207   LI 7,LVAL
       2EB6 2904'
  0835 2EB8 C220   MOV @LP2,8
       2EBA 291A'
  0836 2EBC 06A0   BL @FARG#2
       2EBE 2EAC'
  0837 2EC0 33D0'  DATA LSMPYL
  0838 2EC2 022E   AI 14,4
       2EC4 0004 
  0839            *            if (S!=0)
  0840 2EC6 C220   MOV @S,8
       2EC8 002E'
  0841 2ECA 0288   CI 8,0
       2ECC 0000 
  0842 2ECE 130B   JEQ C$23
  0843            *            {
  0844            */*290 SUM(I)=SUM(I)+MULT*TERM(I) :: GOTO 310*/
  0845            *                laddl(lp1,lval);
  0846 2ED0 C1E0   MOV @LP1,7
       2ED2 2918'
  0847 2ED4 0208   LI 8,LVAL
       2ED6 2904'
  0848 2ED8 06A0   BL @FARG#2
       2EDA 2EBE'
  0849 2EDC 0000   DATA LADDL
  0850 2EDE 022E   AI 14,4
       2EE0 0004 
  0851            *            }
  0852            *            else
  0853 2EE2 0460   B @C$24
       2EE4 2EF8'
  0854            C$23

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0022
  0855            *            {
  0856            */*300 SUM(I)=SUM(I)-MULT*TERM(I)*/
  0857            *                lsubl(lp1,lval);
  0858 2EE6 C1E0   MOV @LP1,7
       2EE8 2918'
  0859 2EEA 0208   LI 8,LVAL
       2EEC 2904'
  0860 2EEE 06A0   BL @FARG#2
       2EF0 2EDA'
  0861 2EF2 2D60'  DATA LSUBL
  0862 2EF4 022E   AI 14,4
       2EF6 0004 
  0863            *            }
  0864            C$24
  0865            *            lp1=lp1+LONGSIZE; lp2=lp2+LONGSIZE;
  0866 2EF8 C220   MOV @LP1,8
       2EFA 2918'
  0867 2EFC 0228   AI 8,4
       2EFE 0004 
  0868 2F00 C808   MOV 8,@LP1
       2F02 2918'
  0869 2F04 C220   MOV @LP2,8
       2F06 291A'
  0870 2F08 0228   AI 8,4
       2F0A 0004 
  0871 2F0C C808   MOV 8,@LP2
       2F0E 291A'
  0872            */*310 NEXT I*/
  0873            *        }
  0874 2F10 0460   B @C$19
       2F12 2E96'
  0875            C$20
  0876            *
  0877            */*320 IF S=0 THEN S=1 ELSE S=0*/
  0878            *        S = (S==0) ? 1 : 0;
  0879 2F14 C220   MOV @S,8
       2F16 002E'
  0880 2F18 0288   CI 8,0
       2F1A 0000 
  0881 2F1C 1604   JNE C$25
  0882 2F1E 0208   LI 8,1
       2F20 0001 
  0883 2F22 0460   B @C$26
       2F24 2F28'
  0884            C$25
  0885 2F26 6208   S 8,8
  0886            C$26
  0887 2F28 C808   MOV 8,@S
       2F2A 002E'
  0888            */*330*/
  0889            *        DoCarry();
  0890 2F2C 069C   BL *12
  0891 2F2E 2F5A'  DATA DOCARR
  0892            *
  0893            */*440 DENOM1=DENOM1+2*/
  0894            *        DENOM1=DENOM1+2;
  0895 2F30 C220   MOV @DENOM1,8
       2F32 0032'
  0896 2F34 0228   AI 8,2

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0023
       2F36 0002 
  0897 2F38 C808   MOV 8,@DENOM1
       2F3A 0032'
  0898            */*450 NEXT N*/
  0899            */*Out();*/
  0900            *    }
  0901 2F3C 0460   B @C$14
       2F3E 2DE6'
  0902            C$15
  0903            *}
  0904 2F40 045D   B *13
  0905 2F42   54  C$13 BYTE 84,101,114,109,32,37,117,32,105,116,101,114
       2F43   65 
       2F44   72 
       2F45   6D 
       2F46   20 
       2F47   25 
       2F48   75 
       2F49   20 
       2F4A   69 
       2F4B   74 
       2F4C   65 
       2F4D   72 
  0906 2F4E   61   BYTE 97,116,105,111,110,32,35,37,117,10,0
       2F4F   74 
       2F50   69 
       2F51   6F 
       2F52   6E 
       2F53   20 
       2F54   23 
       2F55   25 
       2F56   75 
       2F57   0A 
       2F58   00 
  0907             EVEN
  0908            *
  0909            */* Check values of SUM[] */
  0910            *
  0911            *DoCarry()
  0912            DOCARR
  0913            *{
  0914            */*330 FOR I=D TO 2 STEP-1*/
  0915            *    lp1=&SUM[D][0]; lp2=&SUM[D-1][0];
  0916 2F5A 0208   LI 8,SUM
       2F5C 0044'
  0917 2F5E 068F   BL 15
  0918 2F60 C220   MOV @D,8
       2F62 002C'
  0919 2F64 0207   LI 7,2
       2F66 0002 
  0920 2F68 39C8   MPY 8,7
  0921 2F6A A208   A 8,8
  0922 2F6C A23E   A *14+,8
  0923 2F6E C808   MOV 8,@LP1
       2F70 2918'
  0924 2F72 0208   LI 8,SUM
       2F74 0044'
  0925 2F76 068F   BL 15
  0926 2F78 C220   MOV @D,8

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0024
       2F7A 002C'
  0927 2F7C 0228   AI 8,-1
       2F7E FFFF 
  0928 2F80 0207   LI 7,2
       2F82 0002 
  0929 2F84 39C8   MPY 8,7
  0930 2F86 A208   A 8,8
  0931 2F88 A23E   A *14+,8
  0932 2F8A C808   MOV 8,@LP2
       2F8C 291A'
  0933            *    for(I=D; I>=2; --I)
  0934 2F8E C220   MOV @D,8
       2F90 002C'
  0935 2F92 C808   MOV 8,@I
       2F94 002A'
  0936            C$30
  0937 2F96 C220   MOV @I,8
       2F98 002A'
  0938 2F9A 0288   CI 8,2
       2F9C 0002 
  0939 2F9E 1503   JGT $+8
  0940 2FA0 1302   JEQ $+6
  0941 2FA2 0460   B @C$29
       2FA4 3068'
  0942 2FA6 0460   B @C$31
       2FA8 2FB6'
  0943            C$28
  0944 2FAA 0620   DEC @I
       2FAC 002A'
  0945 2FAE C220   MOV @I,8
       2FB0 002A'
  0946 2FB2 0460   B @C$30
       2FB4 2F96'
  0947            C$31
  0948            *    {
  0949            */*340 IF SUM(I)==0 420*/
  0950            *        if (ltst(lp1)!=0)
  0951 2FB6 C220   MOV @LP1,8
       2FB8 2918'
  0952 2FBA 06A0   BL @FARG#1
       2FBC 2E44'
  0953 2FBE 0000   DATA LTST
  0954 2FC0 05CE   INCT 14
  0955 2FC2 0288   CI 8,0
       2FC4 0000 
  0956 2FC6 1602   JNE $+6
  0957 2FC8 0460   B @C$32
       2FCA 304C'
  0958            *        {
  0959            */*350 QUOTIENT=INT(SUM(I)/100000)*/
  0960            *            lcpyl(QUOTIENT,lp1);
  0961 2FCC 0207   LI 7,QUOTIE
       2FCE 2914'
  0962 2FD0 C220   MOV @LP1,8
       2FD2 2918'
  0963 2FD4 06A0   BL @FARG#2
       2FD6 2EF0'
  0964 2FD8 2D72'  DATA LCPYL
  0965 2FDA 022E   AI 14,4

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0025
       2FDC 0004 
  0966            *            LDIV(QUOTIENT,L10000);
  0967 2FDE 0207   LI 7,QUOTIE
       2FE0 2914'
  0968 2FE2 0208   LI 8,L10000
       2FE4 003C'
  0969 2FE6 06A0   BL @FARG#2
       2FE8 2FD6'
  0970 2FEA 33FA'  DATA LSDIVL
  0971 2FEC 022E   AI 14,4
       2FEE 0004 
  0972            *            lgsmod(REMAINDER);
  0973 2FF0 0208   LI 8,REMAIN
       2FF2 290C'
  0974 2FF4 06A0   BL @FARG#1
       2FF6 2FBC'
  0975 2FF8 3434'  DATA LGSMOD
  0976 2FFA 05CE   INCT 14
  0977            *            if (REMAINDER[0]<0) ldec(QUOTIENT);
  0978 2FFC 0208   LI 8,REMAIN
       2FFE 290C'
  0979 3000 C218   MOV *8,8
  0980 3002 0288   CI 8,0
       3004 0000 
  0981 3006 1507   JGT C$33
  0982 3008 1306   JEQ C$33
  0983 300A 0208   LI 8,QUOTIE
       300C 2914'
  0984 300E 06A0   BL @FARG#1
       3010 2FF6'
  0985 3012 0000   DATA LDEC
  0986 3014 05CE   INCT 14
  0987            *            
  0988            */*370 SUM(I-1)=SUM(I-1)+QUOTIENT*/
  0989            *            laddl(lp2,QUOTIENT);
  0990            C$33
  0991 3016 C1E0   MOV @LP2,7
       3018 291A'
  0992 301A 0208   LI 8,QUOTIE
       301C 2914'
  0993 301E 06A0   BL @FARG#2
       3020 2FE8'
  0994 3022 2EDC'  DATA LADDL
  0995 3024 022E   AI 14,4
       3026 0004 
  0996            *            
  0997            */*360 SUM(I)=SUM(I)-QUOTIENT*100000*/
  0998            *            LMPY(QUOTIENT,L10000);
  0999 3028 0207   LI 7,QUOTIE
       302A 2914'
  1000 302C 0208   LI 8,L10000
       302E 003C'
  1001 3030 06A0   BL @FARG#2
       3032 3020'
  1002 3034 33D0'  DATA LSMPYL
  1003 3036 022E   AI 14,4
       3038 0004 
  1004            *            lsubl(lp1,QUOTIENT);
  1005 303A C1E0   MOV @LP1,7

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0026
       303C 2918'
  1006 303E 0208   LI 8,QUOTIE
       3040 2914'
  1007 3042 06A0   BL @FARG#2
       3044 3032'
  1008 3046 2EF2'  DATA LSUBL
  1009 3048 022E   AI 14,4
       304A 0004 
  1010            */*380 GOTO 420*/
  1011            *        }
  1012            *        lp1=lp1-LONGSIZE; lp2=lp2-LONGSIZE;
  1013            C$32
  1014 304C C220   MOV @LP1,8
       304E 2918'
  1015 3050 0228   AI 8,-4
       3052 FFFC 
  1016 3054 C808   MOV 8,@LP1
       3056 2918'
  1017 3058 C220   MOV @LP2,8
       305A 291A'
  1018 305C 0228   AI 8,-4
       305E FFFC 
  1019 3060 C808   MOV 8,@LP2
       3062 291A'
  1020            */*420 NEXT I*/
  1021            *    }
  1022 3064 0460   B @C$28
       3066 2FAA'
  1023            C$29
  1024            */*430 IF FLAG=2 THEN 680*/
  1025            *}
  1026 3068 045D   B *13
  1027            *
  1028            */* DIVIDE SUBROUTINE */
  1029            *
  1030            *SubDivide(DENOM) int DENOM;
  1031            SUBDIV
  1032            *{
  1033            *int I;
  1034            *
  1035            *    lclr(REMAINDER);
  1036 306A 064E   DECT 14
  1037 306C 0208   LI 8,REMAIN
       306E 290C'
  1038 3070 06A0   BL @FARG#1
       3072 3010'
  1039 3074 0000   DATA LCLR
  1040 3076 05CE   INCT 14
  1041            *    lcpys(LDENOM,DENOM);
  1042 3078 0207   LI 7,LDENOM
       307A 2910'
  1043 307C C22E   MOV @6-2(14),8
       307E 0004 
  1044 3080 06A0   BL @FARG#2
       3082 3044'
  1045 3084 2EAE'  DATA LCPYS
  1046 3086 022E   AI 14,4
       3088 0004 
  1047            *    

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0027
  1048            *    lp1 = &TERM[1][0];
  1049 308A 0208   LI 8,TERM
       308C 14A4'
  1050 308E 068F   BL 15
  1051 3090 0208   LI 8,1
       3092 0001 
  1052 3094 0207   LI 7,2
       3096 0002 
  1053 3098 39C8   MPY 8,7
  1054 309A A208   A 8,8
  1055 309C A23E   A *14+,8
  1056 309E C808   MOV 8,@LP1
       30A0 2918'
  1057            *    for (I=1; I<=D; ++I)
  1058 30A2 0208   LI 8,1
       30A4 0001 
  1059 30A6 C788   MOV 8,*14
  1060            C$37
  1061 30A8 C21E   MOV *14,8
  1062 30AA 8808   C 8,@D
       30AC 002C'
  1063 30AE 1103   JLT $+8
  1064 30B0 1302   JEQ $+6
  1065 30B2 0460   B @C$36
       30B4 3198'
  1066 30B6 0460   B @C$38
       30B8 30C0'
  1067            C$35
  1068 30BA 059E   INC *14
  1069 30BC 0460   B @C$37
       30BE 30A8'
  1070            C$38
  1071            *    {
  1072            */*      DIVIDEND=REMAINDER*100000+TERM[I];*/
  1073            *        lcpyl(DIVIDEND,REMAINDER);
  1074 30C0 0207   LI 7,DIVIDE
       30C2 2908'
  1075 30C4 0208   LI 8,REMAIN
       30C6 290C'
  1076 30C8 06A0   BL @FARG#2
       30CA 3082'
  1077 30CC 2FD8'  DATA LCPYL
  1078 30CE 022E   AI 14,4
       30D0 0004 
  1079            *        LMPY(DIVIDEND,L10000);
  1080 30D2 0207   LI 7,DIVIDE
       30D4 2908'
  1081 30D6 0208   LI 8,L10000
       30D8 003C'
  1082 30DA 06A0   BL @FARG#2
       30DC 30CA'
  1083 30DE 33D0'  DATA LSMPYL
  1084 30E0 022E   AI 14,4
       30E2 0004 
  1085            *        laddl(DIVIDEND,lp1);
  1086 30E4 0207   LI 7,DIVIDE
       30E6 2908'
  1087 30E8 C220   MOV @LP1,8
       30EA 2918'

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0028
  1088 30EC 06A0   BL @FARG#2
       30EE 30DC'
  1089 30F0 3022'  DATA LADDL
  1090 30F2 022E   AI 14,4
       30F4 0004 
  1091            *
  1092            */*      TERM[I]=INT(DIVIDEND/DENOM);*/
  1093            *        lcpyl(lp1,DIVIDEND);
  1094 30F6 C1E0   MOV @LP1,7
       30F8 2918'
  1095 30FA 0208   LI 8,DIVIDE
       30FC 2908'
  1096 30FE 06A0   BL @FARG#2
       3100 30EE'
  1097 3102 30CC'  DATA LCPYL
  1098 3104 022E   AI 14,4
       3106 0004 
  1099            *        LDIV(lp1,LDENOM);
  1100 3108 C1E0   MOV @LP1,7
       310A 2918'
  1101 310C 0208   LI 8,LDENOM
       310E 2910'
  1102 3110 06A0   BL @FARG#2
       3112 3100'
  1103 3114 33FA'  DATA LSDIVL
  1104 3116 022E   AI 14,4
       3118 0004 
  1105            *lgsmod(REMAINDER);
  1106 311A 0208   LI 8,REMAIN
       311C 290C'
  1107 311E 06A0   BL @FARG#1
       3120 3072'
  1108 3122 3434'  DATA LGSMOD
  1109 3124 05CE   INCT 14
  1110            *if (REMAINDER[0]<0) ldec(lp1);
  1111 3126 0208   LI 8,REMAIN
       3128 290C'
  1112 312A C218   MOV *8,8
  1113 312C 0288   CI 8,0
       312E 0000 
  1114 3130 1507   JGT C$39
  1115 3132 1306   JEQ C$39
  1116 3134 C220   MOV @LP1,8
       3136 2918'
  1117 3138 06A0   BL @FARG#1
       313A 3120'
  1118 313C 3012'  DATA LDEC
  1119 313E 05CE   INCT 14
  1120            *
  1121            */*      REMAINDER=DIVIDEND-TERM[I]*DENOM;*/
  1122            *        lcpyl(REMAINDER,DIVIDEND);
  1123            C$39
  1124 3140 0207   LI 7,REMAIN
       3142 290C'
  1125 3144 0208   LI 8,DIVIDE
       3146 2908'
  1126 3148 06A0   BL @FARG#2
       314A 3112'
  1127 314C 3102'  DATA LCPYL

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0029
  1128 314E 022E   AI 14,4
       3150 0004 
  1129            */*printf("1 L=%08lX D=%08lX R=%08lX\n",LVAL,DIVIDEND,REMAIN
  1130            *        lcpyl(lval,lp1);
  1131 3152 0207   LI 7,LVAL
       3154 2904'
  1132 3156 C220   MOV @LP1,8
       3158 2918'
  1133 315A 06A0   BL @FARG#2
       315C 314A'
  1134 315E 314C'  DATA LCPYL
  1135 3160 022E   AI 14,4
       3162 0004 
  1136            */*printf("2 L=%08lX D=%08lX R=%08lX\n",LVAL,DIVIDEND,REMAIN
  1137            *        LMPY(lval,LDENOM);
  1138 3164 0207   LI 7,LVAL
       3166 2904'
  1139 3168 0208   LI 8,LDENOM
       316A 2910'
  1140 316C 06A0   BL @FARG#2
       316E 315C'
  1141 3170 33D0'  DATA LSMPYL
  1142 3172 022E   AI 14,4
       3174 0004 
  1143            */*printf("3 L=%08lX D=%08lX R=%08lX\n",LVAL,DIVIDEND,REMAIN
  1144            *        lsubl(REMAINDER,lval);
  1145 3176 0207   LI 7,REMAIN
       3178 290C'
  1146 317A 0208   LI 8,LVAL
       317C 2904'
  1147 317E 06A0   BL @FARG#2
       3180 316E'
  1148 3182 3046'  DATA LSUBL
  1149 3184 022E   AI 14,4
       3186 0004 
  1150            */*printf("4 L=%08lX D=%08lX R=%08lX\n",LVAL,DIVIDEND,REMAIN
  1151            *
  1152            */*printf("%d T=%08lX D=%08lX R=%08lX\n",DENOM, lp1,DIVIDEND
  1153            *waitkey();*/
  1154            *        
  1155            *        lp1=lp1+LONGSIZE;
  1156 3188 C220   MOV @LP1,8
       318A 2918'
  1157 318C 0228   AI 8,4
       318E 0004 
  1158 3190 C808   MOV 8,@LP1
       3192 2918'
  1159            *    }
  1160 3194 0460   B @C$35
       3196 30BA'
  1161            C$36
  1162            *}
  1163 3198 05CE   INCT 14
  1164 319A 045D   B *13
  1165            *
  1166            *
  1167            */* Output to screen */
  1168            *OutScreen()
  1169            OUTSCR

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0030
  1170            *{
  1171            *int ix,jx,kx;
  1172            *
  1173            *    putchar('\f');
  1174 319C 022E   AI 14,-6
       319E FFFA 
  1175 31A0 0201   LI 1,12
       31A2 000C 
  1176 31A4 069C   BL *12
  1177 31A6 0000   DATA XPUTC
  1178            *    locate(1,1); puts("Calculations complete!");
  1179 31A8 0201   LI 1,1
       31AA 0001 
  1180 31AC 0200   LI 0,1
       31AE 0001 
  1181 31B0 069C   BL *12
  1182 31B2 2A26'  DATA XLOCAT
  1183 31B4 0205   LI 5,C$40
       31B6 32B2'
  1184 31B8 069C   BL *12
  1185 31BA 2CFA'  DATA XPUTS
  1186            *
  1187            *    locate(3,1); printf("Pi=3.");
  1188 31BC 0201   LI 1,3
       31BE 0003 
  1189 31C0 0200   LI 0,1
       31C2 0001 
  1190 31C4 069C   BL *12
  1191 31C6 31B2'  DATA XLOCAT
  1192 31C8 0208   LI 8,C$40+23
       31CA 32C9'
  1193 31CC 06A0   BL @FARG#1
       31CE 313A'
  1194 31D0 2E02'  DATA PRINTF
  1195 31D2 05CE   INCT 14
  1196            *    locate(4,1);
  1197 31D4 0201   LI 1,4
       31D6 0004 
  1198 31D8 0200   LI 0,1
       31DA 0001 
  1199 31DC 069C   BL *12
  1200 31DE 31C6'  DATA XLOCAT
  1201            *    for(ix=2, jx=0, kx=4; ix<D; ++ix)
  1202 31E0 0208   LI 8,2
       31E2 0002 
  1203 31E4 CB88   MOV 8,@4(14)
       31E6 0004 
  1204 31E8 6208   S 8,8
  1205 31EA CB88   MOV 8,@2(14)
       31EC 0002 
  1206 31EE 0208   LI 8,4
       31F0 0004 
  1207 31F2 C788   MOV 8,*14
  1208            C$43
  1209 31F4 C22E   MOV @4(14),8
       31F6 0004 
  1210 31F8 8808   C 8,@D
       31FA 002C'
  1211 31FC 1102   JLT $+6

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0031
  1212 31FE 0460   B @C$42
       3200 3294'
  1213 3202 0460   B @C$44
       3204 320E'
  1214            C$41
  1215 3206 05AE   INC @4(14)
       3208 0004 
  1216 320A 0460   B @C$43
       320C 31F4'
  1217            C$44
  1218            *    {
  1219            *        printf(" %04lu", &SUM[ix][0]);
  1220 320E 0208   LI 8,C$40+29
       3210 32CF'
  1221 3212 068F   BL 15
  1222 3214 0208   LI 8,SUM
       3216 0044'
  1223 3218 068F   BL 15
  1224 321A C22E   MOV @8(14),8
       321C 0008 
  1225 321E 0207   LI 7,2
       3220 0002 
  1226 3222 39C8   MPY 8,7
  1227 3224 A208   A 8,8
  1228 3226 A23E   A *14+,8
  1229 3228 068F   BL 15
  1230 322A 069C   BL *12
  1231 322C 31D0'  DATA PRINTF
  1232 322E 022E   AI 14,4
       3230 0004 
  1233            *        if (++jx>4)
  1234 3232 05AE   INC @2(14)
       3234 0002 
  1235 3236 C22E   MOV @2(14),8
       3238 0002 
  1236 323A 0288   CI 8,4
       323C 0004 
  1237 323E 1502   JGT $+6
  1238 3240 0460   B @C$45
       3242 3290'
  1239            *        {
  1240            *            putchar('\n');
  1241 3244 0201   LI 1,10
       3246 000A 
  1242 3248 069C   BL *12
  1243 324A 31A6'  DATA XPUTC
  1244            *            jx = 0;
  1245 324C 6208   S 8,8
  1246 324E CB88   MOV 8,@2(14)
       3250 0002 
  1247            *            if (++kx >= 22)
  1248 3252 059E   INC *14
  1249 3254 C21E   MOV *14,8
  1250 3256 0288   CI 8,22
       3258 0016 
  1251 325A 1503   JGT $+8
  1252 325C 1302   JEQ $+6
  1253 325E 0460   B @C$46
       3260 3290'

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0032
  1254            *            {
  1255            *                locate(24,1); puts("Press any key to contin
  1256 3262 0201   LI 1,24
       3264 0018 
  1257 3266 0200   LI 0,1
       3268 0001 
  1258 326A 069C   BL *12
  1259 326C 31DE'  DATA XLOCAT
  1260 326E 0205   LI 5,C$40+36
       3270 32D6'
  1261 3272 069C   BL *12
  1262 3274 31BA'  DATA XPUTS
  1263            *                waitkey();
  1264 3276 069C   BL *12
  1265 3278 0000   DATA WAITKE
  1266            *                kx=4;
  1267 327A 0208   LI 8,4
       327C 0004 
  1268 327E C788   MOV 8,*14
  1269            *                clearw(kx,20);
  1270 3280 C1DE   MOV *14,7
  1271 3282 0208   LI 8,20
       3284 0014 
  1272 3286 06A0   BL @FARG#2
       3288 3180'
  1273 328A 0000   DATA CLEARW
  1274 328C 022E   AI 14,4
       328E 0004 
  1275            *            }
  1276            *        }
  1277            C$46
  1278            *    }
  1279            C$45
  1280 3290 0460   B @C$41
       3292 3206'
  1281            C$42
  1282            *    locate(24,1); puts("End. Press any key to exit");
  1283 3294 0201   LI 1,24
       3296 0018 
  1284 3298 0200   LI 0,1
       329A 0001 
  1285 329C 069C   BL *12
  1286 329E 326C'  DATA XLOCAT
  1287 32A0 0205   LI 5,C$40+62
       32A2 32F0'
  1288 32A4 069C   BL *12
  1289 32A6 3274'  DATA XPUTS
  1290            *    waitkey();
  1291 32A8 069C   BL *12
  1292 32AA 3278'  DATA WAITKE
  1293            *}
  1294 32AC 022E   AI 14,6
       32AE 0006 
  1295 32B0 045D   B *13
  1296 32B2   43  C$40 BYTE 67,97,108,99,117,108,97,116,105,111,110,115
       32B3   61 
       32B4   6C 
       32B5   63 
       32B6   75 

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0033
       32B7   6C 
       32B8   61 
       32B9   74 
       32BA   69 
       32BB   6F 
       32BC   6E 
       32BD   73 
  1297 32BE   20   BYTE 32,99,111,109,112,108,101,116,101,33,0,80
       32BF   63 
       32C0   6F 
       32C1   6D 
       32C2   70 
       32C3   6C 
       32C4   65 
       32C5   74 
       32C6   65 
       32C7   21 
       32C8   00 
       32C9   50 
  1298 32CA   69   BYTE 105,61,51,46,0,32,37,48,52,108,117,0
       32CB   3D 
       32CC   33 
       32CD   2E 
       32CE   00 
       32CF   20 
       32D0   25 
       32D1   30 
       32D2   34 
       32D3   6C 
       32D4   75 
       32D5   00 
  1299 32D6   50   BYTE 80,114,101,115,115,32,97,110,121,32,107,101
       32D7   72 
       32D8   65 
       32D9   73 
       32DA   73 
       32DB   20 
       32DC   61 
       32DD   6E 
       32DE   79 
       32DF   20 
       32E0   6B 
       32E1   65 
  1300 32E2   79   BYTE 121,32,116,111,32,99,111,110,116,105,110,117
       32E3   20 
       32E4   74 
       32E5   6F 
       32E6   20 
       32E7   63 
       32E8   6F 
       32E9   6E 
       32EA   74 
       32EB   69 
       32EC   6E 
       32ED   75 
  1301 32EE   65   BYTE 101,0,69,110,100,46,32,80,114,101,115,115
       32EF   00 
       32F0   45 
       32F1   6E 

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0034
       32F2   64 
       32F3   2E 
       32F4   20 
       32F5   50 
       32F6   72 
       32F7   65 
       32F8   73 
       32F9   73 
  1302 32FA   20   BYTE 32,97,110,121,32,107,101,121,32,116,111,32
       32FB   61 
       32FC   6E 
       32FD   79 
       32FE   20 
       32FF   6B 
       3300   65 
       3301   79 
       3302   20 
       3303   74 
       3304   6F 
       3305   20 
  1303 3306   65   BYTE 101,120,105,116,0
       3307   78 
       3308   69 
       3309   74 
       330A   00 
  1304             EVEN
  1305            *
  1306            */* test output */
  1307            *Out()
  1308            OUT
  1309            *{
  1310            *    Out1("SUM  ", SUM);
  1311 330C 0207   LI 7,C$47
       330E 335A'
  1312 3310 0208   LI 8,SUM
       3312 0044'
  1313 3314 06A0   BL @FARG#2
       3316 3288'
  1314 3318 3372'  DATA OUT1
  1315 331A 022E   AI 14,4
       331C 0004 
  1316            *    Out1("SUM1 ", SUM1);
  1317 331E 0207   LI 7,C$47+6
       3320 3360'
  1318 3322 0208   LI 8,SUM1
       3324 0A74'
  1319 3326 06A0   BL @FARG#2
       3328 3316'
  1320 332A 3372'  DATA OUT1
  1321 332C 022E   AI 14,4
       332E 0004 
  1322            *    Out1("TERM ", TERM);
  1323 3330 0207   LI 7,C$47+12
       3332 3366'
  1324 3334 0208   LI 8,TERM
       3336 14A4'
  1325 3338 06A0   BL @FARG#2
       333A 3328'
  1326 333C 3372'  DATA OUT1

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0035
  1327 333E 022E   AI 14,4
       3340 0004 
  1328            *    Out1("TEMP ", TEMP);
  1329 3342 0207   LI 7,C$47+18
       3344 336C'
  1330 3346 0208   LI 8,TEMP
       3348 1ED4'
  1331 334A 06A0   BL @FARG#2
       334C 333A'
  1332 334E 3372'  DATA OUT1
  1333 3350 022E   AI 14,4
       3352 0004 
  1334            *    waitkey();
  1335 3354 069C   BL *12
  1336 3356 32AA'  DATA WAITKE
  1337            *}
  1338 3358 045D   B *13
  1339 335A   53  C$47 BYTE 83,85,77,32,32,0,83,85,77,49,32,0
       335B   55 
       335C   4D 
       335D   20 
       335E   20 
       335F   00 
       3360   53 
       3361   55 
       3362   4D 
       3363   31 
       3364   20 
       3365   00 
  1340 3366   54   BYTE 84,69,82,77,32,0,84,69,77,80,32,0
       3367   45 
       3368   52 
       3369   4D 
       336A   20 
       336B   00 
       336C   54 
       336D   45 
       336E   4D 
       336F   50 
       3370   20 
       3371   00 
  1341             EVEN
  1342            *
  1343            *Out1(n, lp) char *n, *lp;
  1344            OUT1
  1345            *{
  1346            *int ix;
  1347            *
  1348            *    puts(n);
  1349 3372 064E   DECT 14
  1350 3374 C16E   MOV @6(14),5
       3376 0006 
  1351 3378 069C   BL *12
  1352 337A 32A6'  DATA XPUTS
  1353            *    for(ix=1; ix<=D; ++ix)
  1354 337C 0208   LI 8,1
       337E 0001 
  1355 3380 C788   MOV 8,*14
  1356            C$51

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0036
  1357 3382 C21E   MOV *14,8
  1358 3384 8808   C 8,@D
       3386 002C'
  1359 3388 1103   JLT $+8
  1360 338A 1302   JEQ $+6
  1361 338C 0460   B @C$50
       338E 33BE'
  1362 3390 0460   B @C$52
       3392 339A'
  1363            C$49
  1364 3394 059E   INC *14
  1365 3396 0460   B @C$51
       3398 3382'
  1366            C$52
  1367            *    {
  1368            *         lp=lp+LONGSIZE; printf(" %5ld", lp);
  1369 339A C24E   MOV 14,9
  1370 339C 0229   AI 9,4
       339E 0004 
  1371 33A0 C219   MOV *9,8
  1372 33A2 0228   AI 8,4
       33A4 0004 
  1373 33A6 C648   MOV 8,*9
  1374 33A8 0207   LI 7,C$48
       33AA 33CA'
  1375 33AC C22E   MOV @6-2(14),8
       33AE 0004 
  1376 33B0 06A0   BL @FARG#2
       33B2 334C'
  1377 33B4 322C'  DATA PRINTF
  1378 33B6 022E   AI 14,4
       33B8 0004 
  1379            *    }
  1380 33BA 0460   B @C$49
       33BC 3394'
  1381            C$50
  1382            *    putchar('\n');
  1383 33BE 0201   LI 1,10
       33C0 000A 
  1384 33C2 069C   BL *12
  1385 33C4 324A'  DATA XPUTC
  1386            *}
  1387 33C6 05CE   INCT 14
  1388 33C8 045D   B *13
  1389 33CA   20  C$48 BYTE 32,37,53,108,100,0
       33CB   25 
       33CC   35 
       33CD   6C 
       33CE   64 
       33CF   00 
  1390             EVEN
  1391            *#ifdef SIGNED
  1392            *#asm
  1393            *lsmpyl(long1, long2) int *long1, *long2;
  1394            *
  1395            * unsigned multiply
  1396            *
  1397            * long1 *= long2 = (LOW(long2) * LOW(long1))            over
  1398            *                + (HOW(long2) * LOW(long1)) 0000       HOW(

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0037
  1399            *                + (LOW(long2) * HOW(long1)) 0000       HOW(
  1400            *                + (HOW(long2) * HOW(long1)) 0000 0000      
  1401            *
  1402            * returns &long1, if overflow occured long1=0xFFFFFFFF 
  1403            *
  1404                   REF LMPY#S
  1405 33D0 04C0  LSMPYL CLR  0           Sign of the result
  1406 33D2 02A1         STWP 1
  1407 33D4 0221         AI   1,2*6 R1=&R6    
       33D6 000C 
  1408 33D8 C868         MOV  @2(8),@2(1) R7=LOW(long2)
       33DA 0002 
       33DC 0002 
  1409 33DE C458         MOV  *8,*1       R6=HOW(long2)
  1410 33E0 06A0         BL   @LABS$1
       33E2 344E'
  1411 33E4 0580         INC  R0          Set sign flag, <>0 means negative
  1412 33E6 C22E         MOV  @4(14),8    R8=&long1
       33E8 0004 
  1413 33EA C048         MOV  8,1
  1414 33EC C0D1         MOV  *1,3
  1415 33EE 06A0         BL   @LABS$1
       33F0 344E'
  1416 33F2 0600         DEC  0           Set sign flag, <>0 means negative
  1417 33F4 06A0         BL   @LMPY#S     Signed multiply
       33F6 0000 
  1418 33F8 1016         JMP  LDIV#Q
  1419            *
  1420            *#asm
  1421            * lsdivl(long1, long2) int *long1,*long2;
  1422            *
  1423            * signed divide
  1424            *
  1425            * long1 = long1 / long2
  1426            * returns &long1
  1427            *
  1428            * R0   = sign of the result
  1429            * R4,5 = long1 / long2
  1430            * R2,3 = long1 % long2
  1431            *
  1432                   REF  LDIV#S
  1433 33FA 04C0  LSDIVL CLR  R0          Sign of the result
  1434 33FC C0AE         MOV  @2(14),2    R2=&long2
       33FE 0002 
  1435 3400 02A1         STWP R1
  1436 3402 0221         AI   1,2*6       R1=&R6
       3404 000C 
  1437 3406 06A0         BL   @LABS$2
       3408 3446'
  1438 340A 0580         INC  0
  1439 340C C0AE  LDIV#A MOV  @4(14),2    R2=&long1
       340E 0004 
  1440 3410 02A1         STWP R1
  1441 3412 0221         AI   1,2*8       R1=&R8
       3414 0010 
  1442 3416 06A0         BL   @LABS$2
       3418 3446'
  1443 341A 0600         DEC  0
  1444 341C 06A0         BL   @LDIV#S     Signed divide

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0038
       341E 0000 
  1445 3420 C604  LDIV#B MOV  4,*8        R8=&long1
  1446 3422 CA05         MOV  5,@2(8)
       3424 0002 
  1447 3426 C040  LDIV#Q MOV  0,1         Must result be negative?
  1448 3428 1303         JEQ  LDIV#C      No!
  1449 342A C048         MOV  8,1
  1450 342C 06A0         BL   @LNEG$
       342E 3452'
  1451 3430 045D  LDIV#C B    *13      
  1452            *
  1453            *#asm
  1454            * lgumod(long) int *long;
  1455            * lgsmod(long) int *long;
  1456            *
  1457            * get unsigned or signed modulo, returns &long;
  1458            *
  1459            * call the apropriate function directly after
  1460            * ldivl() or lsdivl() to retrieve the modulo
  1461            * (remainder) of the division.
  1462            *
  1463            * R1  = sign of the result
  1464            * R2,3 = long1 % long2
  1465            *
  1466 3432 04C1  LGUMOD CLR  1        Clear sign flag
  1467 3434 C602  LGSMOD MOV  2,*8     R8=&long1
  1468 3436 CA03         MOV  3,@2(8)
       3438 0002 
  1469 343A C041         MOV  1,1      Must result be negative?
  1470 343C 1303         JEQ  LGSMD#   No!
  1471 343E C048         MOV  8,1
  1472 3440 06A0         BL   @LNEG$
       3442 3452'
  1473 3444 045D  LGSMD# B    *13
  1474            *
  1475            *#asm
  1476            * LABS$2 R1=&long dest, R2=&long src
  1477            * LABS$1 R1=&long dest, ST according to HOW(long)
  1478            *
  1479            * LABS$: if (long<0) abs(long) returns to *R11
  1480            *        if (long>=0) returns to R11+2
  1481            *
  1482            * LNEG$: long = -long returns to *R11
  1483            *
  1484 3446 C862  LABS$2 MOV  @2(2),@2(1) LOW
       3448 0002 
       344A 0002 
  1485 344C C452         MOV  *2,*1       HOW
  1486 344E 1507  LABS$1 JGT  LABS$#      Long>=0
  1487 3450 1306         JEQ  LABS$#
  1488 3452 0551  LNEG$  INV *1           /HOW->HOW
  1489 3454 0521         NEG @2(1)        -LOW->LOW
       3456 0002 
  1490 3458 1701         JNC LNEG$#
  1491 345A 0591         INC *1           HOW+C
  1492 345C 045B  LNEG$# B   *11
  1493 345E 05CB  LABS$# INCT 11
  1494 3460 045B         B   *11
  1495            *#endif

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0039
  1496             END

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0040
  E ATOI    2A54    E ATOL    0000    ' C$10    2D94    ' C$11    2D34  
  ' C$12    2D54    ' C$13    2F42    ' C$14    2DE6    ' C$15    2F40  
  ' C$16    2DD2    ' C$17    2DF2    ' C$18    2E22    ' C$19    2E96  
  ' C$20    2F14    ' C$21    2E82    ' C$22    2EA2    ' C$23    2EE6  
  ' C$24    2EF8    ' C$25    2F26    ' C$26    2F28    ' C$28    2FAA  
  ' C$29    3068    ' C$3     2B76    ' C$30    2F96    ' C$31    2FB6  
  ' C$32    304C    ' C$33    3016    ' C$35    30BA    ' C$36    3198  
  ' C$37    30A8    ' C$38    30C0    ' C$39    3140    ' C$4     2A5A  
  ' C$40    32B2    ' C$41    3206    ' C$42    3294    ' C$43    31F4  
  ' C$44    320E    ' C$45    3290    ' C$46    3290    ' C$47    335A  
  ' C$48    33CA    ' C$49    3394    ' C$5     2A88    ' C$50    33BE  
  ' C$51    3382    ' C$52    339A    ' C$6     2A08    ' C$7     2A84  
  ' C$8     2D9A    ' C$9     2D48    E C$ASL   0000    E C$ASR   0000  
  E C$CALL  0000    E C$CIND  0000    E C$DIV   2AB4    E C$EQ    0000  
  E C$GE    0000    E C$GT    0000    E C$LE    0000    E C$LNEG  0000  
  E C$LT    0000    E C$NE    0000    E C$REM   2A7C    E C$SWCH  0000  
  E C$UGE   0000    E C$UGT   0000    E C$ULE   0000    E C$ULT   0000  
  E C$VADR  0000    ' CALCPI  2BFA    E CLEARW  328A    E CNULL   0000  
  ' CPYBYT  003A    E CTYPE   0000    ' D       002C    ' DENOM1  0032  
  ' DIVIDE  2908    ' DOCARR  2F5A    E DPRINT  0000    E ERRNO   0000  
  E EXIT    2B70    E FARG#1  31CE    E FARG#2  33B2    E FARG#3  2E00  
  E FARG#4  0000    E FARG#5  2A46    E FARG#6  0000    E FARG#7  0000  
  E FARG#8  0000    ' FLAG    0038    E GETCHA  0000    E GETKEY  0000  
  E GETS    0000    E GETYXT  2A48    E GRMRA   0000    E GRMWA   0000  
  ' I       002A    ' INPLIN  0000    E ISALNU  0000    E ISALPH  0000  
  E ISCNTR  0000    E ISDIGI  0000    E ISGRAP  0000    E ISLOWE  0000  
  E ISPRIN  0000    E ISPUNC  0000    E ISSPAC  0000    E ISUPPE  0000  
  E ISXDIG  0000    ' ITERAT  2DB8    ' ITR     0030    E KBARDL  0000  
  E KBARSP  0000    ' L0      0040    ' L10000  003C    E LABS    0000  
  ' LABS$#  345E    ' LABS$1  344E    ' LABS$2  3446    E LADDL   30F0  
  E LADDS   0000    E LANDL   0000    E LCLR    3074    E LCMPL   0000  
  E LCPYL   315E    E LCPYS   3084    E LDEC    313C    ' LDENOM  2910  
  ' LDIV#A  340C    ' LDIV#B  3420    ' LDIV#C  3430    ' LDIV#Q  3426  
  E LDIV#S  341E    E LDIVL   0000    E LDIVS   0000    ' LGSMD#  3444  
  ' LGSMOD  3434    ' LGUMOD  3432    E LINC    0000    E LINV    0000  
  E LMODL   0000    E LMODS   0000    E LMPY#S  33F6    E LMPYL   0000  
  E LMPYS   0000    E LNEG    0000    ' LNEG$   3452    ' LNEG$#  345C  
  E LOCATE  0000    E LORL    0000    ' LP1     2918    ' LP2     291A  
  ' LSDIVL  33FA    E LSETO   0000    E LSHLS   0000    E LSHRS   0000  
  ' LSMPYL  33D0    E LSTCRU  0000    E LSUBL   3182    E LSUBS   0000  
  E LTST    2FBE    ' LVAL    2904    E LXORL   0000    D MAIN    291C  
  E MEMCMP  0000    E MEMCPY  0000    E MEMMOV  0000    E MEMSET  2CBA  
  ' MULT    0036    ' N       0028    ' OUT     330C    ' OUT1    3372  
  ' OUTSCR  319C    E POLL    0000    E PRINTF  33B4    E PUTCHA  0000  
  E PUTS    0000    ' QUOTIE  2914      R0      0000      R1      0001  
    R10     000A      R11     000B      R12     000C      R13     000D  
    R14     000E      R15     000F      R2      0002      R3      0003  
    R4      0004      R5      0005      R6      0006      R7      0007  
    R8      0008      R9      0009    ' REMAIN  290C    ' S       002E  
  E S$LOC   0000    E SLDIVS  0000    E SPRINT  0000    E STRCAT  0000  
  E STRCHR  0000    E STRCMP  0000    E STRCPY  0000    E STRLEN  0000  
  E STRNCM  0000    E STRNCP  0000    ' SUBDIV  306A    D SUM     0044  
  D SUM1    0A74    ' TBASE   0034    D TEMP    1ED4    D TERM    14A4  
  E THSCRU  0000    E TOLOWE  0000    E TOUPPE  0000    E TSCRN   0000  
  E VDPWD   0000    E VMBR    0000    E VMBW    0000    E VSBR    0000  
  E VSBW    0000    E WAITKE  3356    E XCTOI   0000    E XDPUTS  0000  
  E XGETS   0000    E XLOCAT  329E    E XMCPY   2E3C    E XMMOV   0000  
  E XMSET   0000    E XPOLL   0000    E XPUTC   33C4    E XPUTS   337A  

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0041
  E XSCAT   0000    E XSCHR   0000    E XSCMP   0000    E XSCPY   0000  
  E XSLEN   0000    E XSNCMP  0000    E XSNCPY  0000    E XTOI    0000  
  E XTOL    0000    E XTSCRN  0000    E XVMBR   0000    E XVMBW   0000  
  E XVSBW   0000    E XVWTR   0000  
  0000 ERRORS

 Xa99 Cross Assembler
VERSION 2.2/A                                                PAGE 0042
  SEGMENT RORG     SIZE 13410 (>3462) BYTES
